package psw2.JIM;

import java.applet.*;
import java.awt.*;
import java.awt.image.*;

public class JIMCCannon extends JIMMComponent { 
  final String BULLETCLASS="BallCannon";
    public static JIMPolygon classpoly;
    
    int ignited=0;  //to indicate how long the fuse is still to burn
  int heat=0; //accumulated heat
  
  boolean firedCannon;
  
  JIMFactory factory;
  {
    int xpoints[]=new int[] { 0,12,85,91,91,85,77,75,72,62,58,58,35,31,23,18,12, 0};
      int ypoints[]=new int[] { 8, 7, 7,13,19,25,26,32,35,35,31,27,27,35,35,27,26,23};
      
    classpoly=new JIMPolygon(xpoints,ypoints,new Rectangle(0,0,96,36));
    };

  public JIMCCannon() {
    super();

    isResizeNS= false;
    isResizeWE= false;
    isFixed=true;

    firedCannon=false;
    
    setSize(new Dimension(96,36));
    heatSensorList.addElement(new JIMPropertyPoint(89,4));
  }
  
  public void loadedInit() {    
    factory= app.factory;
  };
  
    public void newMachineTurn()
  {
    JIMPropertyPoint ppt;
    for (int i=0;i<heatSensorList.size();i++)
    {
      ppt=(JIMPropertyPoint)heatSensorList.elementAt(i);
      heat+=2*ppt.property;
      ppt.property=0;
    }
    if (heat>0) heat--; //cool down automatically
    if ((!firedCannon) && (ignited==0) && (heat>50)) ignite();
    if (ignited>0)
    {   
      if (ignited==1) fireCannon();
      ignited--;
    }
  }

  private void ignite()
  {
    ignited=50;
      
  }
  
  private void fireCannon()
  {
    if (!firedCannon)
    { firedCannon=true;
      image=images[((-orientation+1)>>1)+2];
      JIMMComponent cannonball= factory.createJIMMComponent(BULLETCLASS, getLocation().x+50-67*orientation, getLocation().y+11);
          cannonball.vx=-96*orientation;
      cannonball.vy=0;      
    }
  }
    
  public void paint(Graphics g) {
    super.paint(g);
    if (ignited>0) g.drawImage(images[4+(ignited&3)], 50+orientation*(43+(ignited>>3)),3, this);
    };

};