package psw2.JIM;

import java.applet.*;
import java.awt.*;
import java.awt.image.*;

public class JIMCFlashlight extends JIMMComponent {
  public static JIMPolygon classpoly;
  public static JIMPolygon conepoly;
  
  boolean turnedon;

  {
    int xpoints[]=new int[] { 9,16,18,25,25,29,29,38,39,37,18,16, 9, 8};
	 int ypoints[]=new int[] { 0, 0, 3, 3, 1, 1, 3, 3, 7,11,11,15,15, 7};
  	  
 	 classpoly=new JIMPolygon(xpoints,ypoints,new Rectangle(0,0,40,16));
 	  
 	 int conex[]=new int[] {-16,16,-16};
	 int coney[]=new int[] {-7,8,23};
	  
	 conepoly=new JIMPolygon(conex,coney);	
  }

  public JIMCFlashlight() {
	 super();

  	 isResizeNS= false;
	 isResizeWE= false;
  	 isFixed=true;

	 setSize(new Dimension(40,16));
	  
	 turnedon=false;
  }

  public void onCollision(int vertexidx, int jcvertexidx, JIMMComponent jc) {
    if ((vertexidx>=(orientation==1?3:8)) && (vertexidx<=(orientation==1?5:10)))
	   turnon();
  };

  public void turnon()
  {
    if (!turnedon)
    {
		JIMPolygon toaddpoly=new JIMPolygon(conepoly);
      if (orientation==-1){
	    toaddpoly.mirror(getSize().width/2);}
	    turnedon=true;
	    lightShedderList.addElement(toaddpoly);
	    image=images[((-orientation+1)>>1)+2];
	 }
  }  
  public void turnoff()
  {
	 if (turnedon)
	 {
	   turnedon=false;
	   lightShedderList.removeAllElements();
	   image=images[((-orientation+1)>>1)];
	 }
  }  	
  
  
};