package psw2.JIM;

import java.applet.*;
import java.awt.*;
import java.awt.image.*;

public class JIMCGearWheel extends JIMMComponent {	
  public static JIMPolygon classpoly;
  {
    int xpoints[]=new int[] {16,19,24,24,29,27,30,26,28,23,23,18,15,11, 6, 6, 1, 4, 0, 4, 2, 7, 7, 12}; 
    int ypoints[]=new int[] { 0, 4, 2, 7, 8,12,16,19,24,24,29,27,30,26,28,23,23,19,14,11, 6, 6, 1, 3}; 
      
    classpoly=new JIMPolygon(xpoints,ypoints);
  };
  
  boolean isSharp;  //when JIMCGearWheel rotates it gets sharp
  
  public JIMCGearWheel() {
    super();

    isMirrorable= false;
    isResizeNS= false;
    isResizeWE= false;
    isLocked= false;
    isFixed= true;
    isSharp= false;
    
    setSize(new Dimension(31, 31));
    connectionPoint= new Point(15, 15);
  };
  
  
  /** changes the sharpness property of JIMCGearWheel */
  private void setSharpness(int sharpness) {
    for (int i=0; i<this.poly.vert_prop.length; i++)
      this.poly.vert_prop[i]= sharpness;
        
    this.isSharp= (sharpness == JIMPolygon.SHARP_VERTEX);    
  };
  
  
  public void onRotate() {
    ani= ani+rotation;
    
    if (ani == -1) 
      ani= 2;
    else if (ani == 3) 
      ani= 0;
      
    image= images[ani];
  };
    
    
  public void newMachineTurn() {
	 if (rotation != 0) {
      if (!isSharp) 
        setSharpness(JIMPolygon.SHARP_VERTEX);
      onRotate();
      
	   JIMCGearWheel gw= null;
	   int rot;
	    
	   //iterate over auto-connected JIMCGearWheels and set their rotation correctly
	   for (int i=0; i<rotateList.size(); i++) {
	     gw= (JIMCGearWheel)rotateList.get(i);  	      	      
	     rot= gw.getRotation();
	      
	     if (((rot != 0)&&(rot == this.rotation))||(this.blocked)) { 
	       this.blocked= true;
	       this.rotation= 0;
	       gw.setBlocked(true);
	       gw.setRotation(0);
	     }else {
	       gw.setRotation(this.rotation*-1);
	     };
	   };
    }else if (isSharp)  //if rotation has stopped vertices are no longer sharp!
	   setSharpness(JIMPolygon.PLAIN_VERTEX);	  
  };  
};