package psw2.JIM;

import java.applet.*;
import java.awt.*;
import java.awt.image.*;

public class JIMCLens extends JIMMComponent {
  public static JIMPolygon classpoly;
  public static JIMPolygon heatpoly;
   
  {
    int xpoints[]=new int[] { 3, 8,12, 9, 9, 5, 5};
    int ypoints[]=new int[] { 7, 1, 7,16,31,31,17};
       
    classpoly=new JIMPolygon(xpoints,ypoints, new Rectangle(0,0,16,32));
      
    int heatx[]=new int[] {-24,8,-24};
    int heaty[]=new int[] {-7,8,23};
     
    heatpoly=new JIMPolygon(heatx,heaty);
  }

  public JIMCLens() {
    super();

    isResizeNS= false;
    isResizeWE= false;
    isFixed=true;
     
    lightSensorList.addElement(new JIMPropertyPoint(19,7));
     
    setSize(new Dimension(16,32));
  }   
   
  public void newMachineTurn()
  {
    int lightsum=0;
    JIMPropertyPoint ppt;
    for (int i=0;i<lightSensorList.size();i++)
    {
      ppt=(JIMPropertyPoint)lightSensorList.elementAt(i);
      lightsum+=ppt.property;
    }
    if (heatShedderList.size()==0) 
    {   
      if (lightsum>=1) 
      {
        JIMPolygon toaddpoly=new JIMPolygon(heatpoly);
        image=images[((-orientation+1)>>1)+2];            
        if (orientation==-1) toaddpoly.mirror(getSize().width/2);
          heatShedderList.addElement(toaddpoly);
      }
    }else
      if (lightsum==0) 
      {   
        image=images[(-orientation+1)>>1];
        heatShedderList.removeAllElements();
      }
  }
   
};