package psw2.JIM;

import java.awt.*;

public class JIMMWall extends JIMMComponent {
  int desiredwidth=0;
  int desiredheight=0;
  
  public static JIMPolygon classpoly;
  {
    int xpoints[]=new int[] {0,32,32,0};
    int ypoints[]=new int[] {0,0,32,32};            
          
    classpoly=new JIMPolygon(xpoints,ypoints);
 
  }

  public JIMMWall() {
    super();
          
    isMirrorable= false;
    isFixed=true;

    setBounds(0,0,32,32);
  }
  public void loadedInit(){
    image=null;
  }

  public void allImagesLoaded()
  {
	generateImage();
  }        

  public void setBounds(int x, int y, int width, int height) {
    super.setBounds(x,y,width,height);
    generateImage(width,height);
  }
  
  public void setSize(int width, int height){
    super.setSize(width,height);
    generateImage(width,height);
  }
  
  public void generateImage(int width, int height){
    desiredwidth=width;
    desiredheight=height;
    generateImage();
  }
  
  public void generateImage(){    
    if ((getParent()!=null) && (images[0]!=null) && (desiredwidth>0) && (desiredheight>0))
    {      
      image=createImage(desiredwidth,desiredheight);
      if (image!=null)
      {
        Graphics g=image.getGraphics();
        for (int dx=0;dx<desiredwidth;dx+=images[0].getWidth(this))
          for (int dy=0;dy<desiredheight;dy+=images[0].getHeight(this))
            g.drawImage(images[0],dx,dy,this);                      
      }
    }

  }

}