package psw2.JIM;

import java.applet.*;
import java.awt.*;
import java.awt.image.*;

public class JIMCBalloon extends JIMMComponent {
  public static JIMPolygon classpoly;
	
  {
    int xpoints[]=new int[] {18,31,35,30,19,21,15,17, 6, 0, 6};
    int ypoints[]=new int[] { 0, 6,20,38,46,49,49,46,40,21, 5};
  	 classpoly=new JIMPolygon(xpoints,ypoints,new Rectangle(38,62));
  }

  private boolean isPopped= false;
  private int counter= 5;  //number of machineTurns a ballon is shown after it has popped    
	
  public JIMCBalloon() {
	 super();
         isMirrorable= false;
  	 isResizeNS= false;
	 isResizeWE= false;
	 lift=2;
	 weight=2;
	 setSize(new Dimension(38,62));
  };
  
  /** makes the ballon pop */
  private void pop() {
    this.image= images[1];
    isPopped= true;
  };   
	
  public void onCollision(int vertexidx, int jcvertexidx, JIMMComponent jc) {
    if ((jc.poly.vert_prop[jcvertexidx]&JIMPolygon.SHARP_VERTEX) == JIMPolygon.SHARP_VERTEX)
	 pop();
  };	
		
  public void newMachineTurn() {
    if ((isPopped)&&(--counter == 0)) {
      app.mapContainer.remove(this);
      app.jcList.removeElement(this);
	 };
  };	
};