package psw2.JIM;

import java.applet.*;
import java.awt.*;
import java.awt.image.*;

public class JIMCJackInTheBox extends JIMMComponent {
  boolean ok= true;
  private int trigger= 30;
  
  public static JIMPolygon classpoly;
  {
    int xpoints[]=new int[] {0, 29, 29, 0};
    int ypoints[]=new int[] {0,  0, 29, 29};      
    
    classpoly=new JIMPolygon(xpoints,ypoints);
  };

  public JIMCJackInTheBox() {
    super();

    isMirrorable= false;
    isResizeNS  = false;
    isResizeWE  = false;
    isFixed     = true;
    
    setSize(new Dimension(30, 30));
    connectionPoint= new Point(15, 15);
  };  
  
  
  public void onCollision(int vertexidx, int jcvertexidx, JIMMComponent jc) {	    
	  if ((ok)&&(trigger <= 4)) {
	    jc.vy-= 1;
	    jc.vx+= 2*this.rotation;
	  };
  };  
  
  
  public void onRotate() {
    if ((ok)&&(--trigger == 0))
      jumpOut();    
  };
    
    
  public void newMachineTurn() {
	 if (rotation != 0) 
	   onRotate();  
  };
 
  
  public void startMachine() {
    JIMMComponent jc;
    Rectangle r0, r1;
    int i= 0;  //counter variable

    //check out, if it is ok for Jack to jump out of his box    
    //first alter size and see if collisions with fixed objects occur
    r0= new Rectangle(this.getLocation().x, this.getLocation().y-30,
                      this.getSize().width, this.getSize().height);    
    
    while ((ok)&&(++i < app.jcList.size())) {
      jc= (JIMMComponent)app.jcList.get(i);
      //leave out RubberBands
      if (!(jc instanceof JIMCRubberBand)) {
        r1= new Rectangle(jc.getLocation().x, jc.getLocation().y,
                          jc.getSize().width, jc.getSize().height);    
      
        //JIMCJackInTheBox must not collide with locked Components
        ok= ((!jc.isFixed)||(!r1.intersects(r0)));
      };
    }      
  }
  
  
  /** makes Jack jump out of the box */
  private void jumpOut() {    
    this.image= images[1];      
    this.fpay-= 24<<4;
    setSize(new Dimension(30, 53));
    updatePolygon();
  }
}